﻿'
'   Change File Name Classic fixed Ver.
'
'     InputStrings MaxLength (Form.MaxWidth=1280)
'
'       ANK : 172
'       全角: 110
'
'     96Dpi 版 1.1.8.0 (AltTm NC 10p, AltFl NC 10p 共用) AreaCheck
'
'       Required Class:
'         ButtonEx.vb
'         CheckBoxSL.vb
'         LabelSL.vb
'
'       Required Property:
'         Owner.Font
'         Owner.ListView.Font
'         Owner.HoverColor
'
Imports System.IO
Imports System.Text.RegularExpressions

Public Class Form_F2

#Region "// constant, variable declaration"

    Private _onMouse As Boolean
    Private _Me_Rect As Rectangle               'onMouse 判定用

 'フォーム(クライアント)のサイズ
    Private _MinClientWidth As Integer
    Private _MaxClientWidth As Integer

    Private _FixClientHeight As Integer         '固定（基準値） 

    Private _MinClientSize As Size
    Private _MaxClientSize As Size

 'テキストボックス関連の最大値（幅）
    Private Const _MaxWidth = 1280

    Private _fName As String
    Private _wName As String

    Private _ClipboardMonitor As Boolean

    Private _PreviousTextLength As Integer
    Private _PreviousTextWidth As Integer

    Private _TextWidth As Integer

    Private _Remove_FileNamePattern As String = String.Format("[{0}]", Regex.Escape(Path.GetInvalidFileNameChars()))

#End Region

#Region "// Sub-Routine & Function"

    Private Function GetTextWidth(ByVal Text As String, ByVal MaxWidth As Integer, ByVal ExtensionChecked As Boolean) As Integer

        Dim b As New Bitmap(MaxWidth, Txt_AfterName.Height)
        Dim g As Graphics = Graphics.FromImage(b)
        Dim f As Font = New Font(Txt_AfterName.Font, FontStyle.Regular)
        Dim m As Integer = Convert.ToInt32(f.Size / 4)  '右余白

        If ExtensionChecked Then Text = Text & ".XXX." '拡張子相当の右余白を加算

        Dim w As Integer = TextRenderer.MeasureText(g, Text, f).Width + m

        f.Dispose()
        g.Dispose()
        b.Dispose()

        f = Nothing
        g = Nothing
        b = Nothing

        Return w
    End Function

    Private Sub SetTextWidth()
        _TextWidth = GetTextWidth(Txt_BeforeName.Text, _MaxWidth, False)

        Dim w As Integer = GetTextWidth(Txt_AfterName.Text, _MaxWidth, Chk_Ext.Checked)
        If w > _TextWidth Then _TextWidth = w
    End Sub

    Private Sub Btn_Clip_Control()

        Dim s As Boolean = Clipboard.ContainsText

        If s Then
           s = Not String.IsNullOrEmpty(Clipboard.GetText.TrimStart)
        End If

        If Btn_Clip.Enabled <> s Then
           Btn_Clip.Enabled = s
        End If
    End Sub

    Private Sub Form_Build()

     'Owner Data Set
        Me.Font = DirectCast(Owner, Form).Font

        Dim c As Color = DirectCast(Owner.GetType.GetProperty("HoverColor").GetValue(Owner, Nothing), Color)

        Chk_Ext.HoverColor = c
        Btn_Ok.HoverColor = c
        Btn_Cancel.HoverColor = c

        Dim f As Font = DirectCast(Owner, Form).Controls("ListView").Font
        Dim s As Single = f.Size

        Txt_BeforeName.Font = f
        Txt_AfterName.Font = f
'-------------------------------------------------------------------------------
     'テキストボックスの高さを取得
        Dim h As Integer = Txt_BeforeName.Height

     'Txt_AfterNameの位置を修正
        Txt_AfterName.Top = Txt_BeforeName.Top + (h + 4)

     'ラベルの位置，高さを修正
        Lbl_After.Top = Txt_AfterName.Top
        Lbl_Before.FixHeight = Txt_BeforeName.Height
        Lbl_After.FixHeight = Txt_AfterName.Height
'-------------------------------------------------------------------------------
     '設計値 (TextBox.Height:20) を基準として、フォームの高さを修正

        h = 2 * (h - 20)    'Height 差分

        Me.Height += h
'-------------------------------------------------------------------------------
     '画面制御変数・初期化
        Dim fw As Integer = SystemInformation.FrameBorderSize.Width * 2
        Dim fh As Integer = SystemInformation.CaptionHeight + fw

        _MinClientWidth = 340 - fw
        _MaxClientWidth = 1280 - fw

        _FixClientHeight = Me.ClientSize.Height
        _MinClientSize = New Size(_MinClientWidth, _FixClientHeight)
        _MaxClientSize = New Size(_MaxClientWidth, _FixClientHeight)

        Me.MinimumSize = New Size(_MinClientWidth + fw, Me.Height)
        Me.MaximumSize = New Size(_MaxClientWidth + fw, Me.Height)
'-------------------------------------------------------------------------------
     'テキストボックスの幅を補正
        _TextWidth = GetTextWidth(_wName, _MaxWidth, Chk_Ext.Checked)

        If _TextWidth > Txt_AfterName.Width Then
           Me.Width += (_TextWidth - Txt_AfterName.Width)
        End If

     'ラベルの上余白を設定（センタリング）
        Dim p As Integer = (Txt_BeforeName.Height - Txt_BeforeName.Font.Height) \ 2 + 1
        Txt_BeforeName.Padding = New Padding(0, p, 0, 0)

        Txt_BeforeName.Text = _wName
        Txt_AfterName.Text = _wName

     '変更前の文字列情報セット（Btn_ReSize 表示，制御用）
        _PreviousTextLength = _wName.Length
        _PreviousTextWidth = _TextWidth

        Chk_Ext.Checked = False
        Btn_Ok.Visible = False
    End Sub

#End Region

    Public Overloads Sub Show(
           ByVal Owner As IWin32Window,
           ByRef FileName As String,
           ByRef ExtensionChecked As Boolean,
           ByVal ClipboardMonitor As Boolean)

     'ファイル名セット
        _fName = FileName.TrimStart
        _wName = Path.GetFileNameWithoutExtension(FileName).TrimStart

        _ClipboardMonitor = ClipboardMonitor

        Me.ShowDialog(Owner)

        If Me.DialogResult = DialogResult.OK Then
           FileName = Txt_AfterName.Text
           ExtensionChecked = Chk_Ext.Checked
        End If
    End Sub

#Region "// ---- Form & Timer -----------------------------------------------------------"

''' <summary>
''' マウスがフォーム内のコントロール上にある場合等に、フォームの Enter / Leave イベントが
''' 正しく発生しない為、Timer を使用してクリップボードの簡易チェックを行う
''' </summary>

    Private Sub AreaCheckTimer_Tick(sender As Object, e As EventArgs)

        If _Me_Rect.Contains(Me.PointToClient(Cursor.Position)) Then
           If Not _onMouse Then
              _onMouse = True

              Btn_Clip_Control()
           End If
        Else
           _onMouse = False
        End If
    End Sub

    Private Sub ClipboardCheckTimer_Tick(sender As Object, e As EventArgs)

        Btn_Clip_Control()
    End Sub

    Private Sub Me_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load

      Me.SuspendLayout()

        Form_Build()

        If _ClipboardMonitor Then

           Me.Text &= " - Monitoring -"

           Btn_Clip_Control()

           AreaCheckTimer.Interval = 200
           ClipboardCheckTimer.Interval = 500
           ClipboardCheckTimer.Start()

           _Me_Rect = New Rectangle(New Point(0, 0), Me.ClientSize)

           AddHandler Me.Activated, AddressOf Me_Activated
           AddHandler Me.Deactivate, AddressOf Me_Deactivate
           AddHandler Me.FormClosed, AddressOf Me_FormClosed
           AddHandler Me.ResizeBegin, AddressOf Me_ResizeBegin

           AddHandler AreaCheckTimer.Tick, AddressOf AreaCheckTimer_Tick
           AddHandler ClipboardCheckTimer.Tick, AddressOf ClipboardCheckTimer_Tick
        Else
           Btn_Clip.Enabled = True
        End If

      Me.ResumeLayout()

        Txt_AfterName.SelectAll()

        AddHandler Me.Resize, AddressOf Me_Resize
        AddHandler Txt_AfterName.TextChanged, AddressOf Txt_AfterName_TextChanged
    End Sub

    Private Sub Me_Activated(sender As Object, e As EventArgs)

        If AreaCheckTimer.Enabled Then
           AreaCheckTimer.Stop()
        End If

        If Not ClipboardCheckTimer.Enabled Then
           ClipboardCheckTimer.Start()
        End If

        If Not _onMouse Then
           Btn_Clip_Control()
        End If
    End Sub

    Private Sub Me_Deactivate(sender As Object, e As EventArgs)
        _onMouse = False

        ClipboardCheckTimer.Stop()
        AreaCheckTimer.Start()
    End Sub

    Private Sub Me_FormClosed(sender As Object, e As FormClosedEventArgs)
        ClipboardCheckTimer.Stop()
    End Sub

    Private Sub Me_ResizeBegin(sender As Object, e As EventArgs)
        ClipboardCheckTimer.Stop()
    End Sub

    Private Sub Me_Resize(ByVal sender As Object, ByVal e As EventArgs)

'---------------------------------------------------------------------------------------------
'     画面のプロパティ(アクティブタイトルバー、ウィンドウの境界・間隔)が変更された時の処理
'     （ウィンドウサイズの変更のみ実施）
'---------------------------------------------------------------------------------------------
        Dim fw As Integer = SystemInformation.FrameBorderSize.Width * 2
        Dim fh As Integer = SystemInformation.CaptionHeight + fw
        Dim mw As Integer = _MinClientSize.Width + fw
        Dim mh As Integer = _MinClientSize.Height + fh

        If Me.Size = Me.MinimumSize Then

           If mw < Me.MinimumSize.Width OrElse mh < Me.MinimumSize.Height Then

              RemoveHandler Me.Resize, AddressOf Me_Resize

                Me.MinimumSize = New Size(mw, mh)
                Me.Size = Me.MinimumSize

              AddHandler Me.Resize, AddressOf Me_Resize
           End If
        Else
           If mw <> Me.MinimumSize.Width OrElse mh <> Me.MinimumSize.Height Then

              Me.MinimumSize = New Size(mw, mh)
           End If
        End If

        mw = _MaxClientSize.Width + fw
        mh = _MaxClientSize.Height + fh

        If Me.Size = Me.MaximumSize Then

           If mw > Me.MaximumSize.Width OrElse mh > Me.MaximumSize.Height Then

              RemoveHandler Me.Resize, AddressOf Me_Resize

                Me.MaximumSize = New Size(mw, mh)
                Me.Size = Me.MaximumSize

              AddHandler Me.Resize, AddressOf Me_Resize
           End If
        Else
           If mw <> Me.MaximumSize.Width OrElse mh <> Me.MaximumSize.Height Then

              Me.MaximumSize = New Size(mw, mh)
           End If
        End If

        If _ClipboardMonitor Then
           _Me_Rect = New Rectangle(New Point(0, 0), Me.ClientSize)
        End If
    End Sub

    Private Sub Me_ResizeEnd(ByVal sender As Object, ByVal e As EventArgs) Handles Me.ResizeEnd

        SetTextWidth()

        Btn_ReSize.Visible = (Me.Width < _MaxWidth) AndAlso (Txt_AfterName.Width < _TextWidth)

        If _ClipboardMonitor Then
           ClipboardCheckTimer.Start()
        End If
    End Sub

#End Region

#Region "// Label, TextBox, CheckBox"

    Private Sub Lbl_Before_MouseDown(sender As Object, e As MouseEventArgs) Handles Lbl_Before.MouseDown
        If e.Button = MouseButtons.Middle Then
           Txt_AfterName.Text = Txt_BeforeName.Text
           Txt_AfterName.SelectAll()
           Txt_AfterName.Select()
        End If
    End Sub

    Private Sub Lbl_After_MouseDown(sender As Object, e As MouseEventArgs) Handles Lbl_After.MouseDown
        If e.Button = MouseButtons.Middle Then
           Txt_AfterName.SelectAll()
           Txt_AfterName.Select()
        End If
    End Sub

    Private Sub Txt_AfterName_Control()

'   テキストの内容が変わった際に強制的に入力枠を変更すると、入力枠内に文字がすべて表示されない
'   （右側に余白が生じる）のを避けるための処理

        Dim CursorPos As Integer = Txt_AfterName.SelectionStart
        Dim SelLength As Integer = Txt_AfterName.SelectionLength

        Txt_AfterName.SelectionStart = 0
        Txt_AfterName.SelectionLength = 0
        Txt_AfterName.SelectionStart = CursorPos
        Txt_AfterName.SelectionLength = SelLength
    End Sub

    Private Sub Txt_AfterName_MouseDown(sender As Object, e As MouseEventArgs) Handles Txt_AfterName.MouseDown
     'Home
        If e.Button = MouseButtons.Middle Then
           Txt_AfterName.SelectionLength = 0
           Txt_AfterName.SelectionStart = 0
        End If
    End Sub

    Private Sub Txt_AfterName_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) Handles Txt_AfterName.KeyDown
        If e.KeyData = DirectCast(131137, Keys) Then    '[ctrl]+A
           e.SuppressKeyPress = True                    'KeyPressイベントをキャンセル
           Txt_AfterName.SelectAll()
        End If
    End Sub

    Private Sub Txt_AfterName_KeyPress(ByVal sender As Object, ByVal e As KeyPressEventArgs) Handles Txt_AfterName.KeyPress
        If Txt_AfterName.SelectionStart = 0 AndAlso Char.IsWhiteSpace(e.KeyChar) Then
           Beep()
           e.Handled = True
        End If
    End Sub

    Private Sub Txt_AfterName_TextChanged(ByVal sender As Object, ByVal e As EventArgs) 'Handles Txt_AfterName.TextChanged

        ClipboardCheckTimer.Stop()

        Dim old_Text As String = Txt_AfterName.Text
        Dim new_Text As String = Regex.Replace(old_Text, _Remove_FileNamePattern, "").TrimStart

        If old_Text <> new_Text Then
           Dim OldCursorPosition As Integer = Txt_AfterName.SelectionStart
           Dim NewCursorPosition As Integer = OldCursorPosition + (new_Text.Length - old_Text.Length)

           If NewCursorPosition < 0 Then NewCursorPosition = 0

           RemoveHandler Txt_AfterName.TextChanged, AddressOf Txt_AfterName_TextChanged

             Txt_AfterName.Text = new_Text
             Txt_AfterName.SelectionStart = NewCursorPosition

           AddHandler Txt_AfterName.TextChanged, AddressOf Txt_AfterName_TextChanged
        End If

        Btn_Ok.Visible = (Txt_AfterName.TextLength <> 0) AndAlso _
                         (Txt_AfterName.Text <> Txt_BeforeName.Text)

        SetTextWidth()

        Dim f As Boolean = (Me.Width < _MaxWidth) AndAlso (Txt_AfterName.Width < _TextWidth)
        Dim h As Integer = Convert.ToInt32(Me.FontHeight * 0.8)

        If f AndAlso (
           ((Txt_AfterName.TextLength - _PreviousTextLength) > 1) OrElse
           ((_TextWidth - _PreviousTextWidth) > h)
           ) Then

           Btn_ReSize_Click(Me, New EventArgs)
        Else
           Btn_ReSize.Visible = f
        End If

        _PreviousTextLength = Txt_AfterName.TextLength
        _PreviousTextWidth = _TextWidth

        ClipboardCheckTimer.Start()
    End Sub

    Private Sub Chk_Ext_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Chk_Ext.Click
        If Chk_Ext.Checked Then
           Txt_BeforeName.Text = _fName
        Else
           Txt_BeforeName.Text = _wName
        End If

        Btn_Ok.Visible = (Txt_AfterName.TextLength <> 0) AndAlso _
                         (Txt_AfterName.Text <> Txt_BeforeName.Text)

        SetTextWidth()

        RemoveHandler Me.Resize, AddressOf Me_Resize
          Me.Width += (_TextWidth - Txt_AfterName.Width)
        AddHandler Me.Resize, AddressOf Me_Resize

        Txt_AfterName.SelectionStart = Txt_AfterName.TextLength
        Txt_AfterName.SelectionLength = 0
        Txt_AfterName_Control()
        Txt_AfterName.Select()

        Btn_ReSize.Visible = False
    End Sub

#End Region

#Region "// Button"

    Private Sub Btn_ReSize_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Btn_ReSize.Click

        RemoveHandler Me.Resize, AddressOf Me_Resize
          Me.Width += (_TextWidth - Txt_AfterName.Width)
        AddHandler Me.Resize, AddressOf Me_Resize

        Dim bw As Integer = Screen.GetBounds(Me).Width
        Dim x0 As Integer = Me.Location.X
        Dim x1 As Integer = Me.Width + x0

        If x1 > bw Then
           Me.Location = New Point(x0 - (x1 - bw), Me.Location.Y)
        End If

        Txt_AfterName_Control()
        Txt_AfterName.Select()

        Btn_ReSize.Visible = False
    End Sub

    Private Sub Btn_Clip_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs) Handles Btn_Clip.MouseDown
        If e.Button = MouseButtons.Middle Then

        'クリップボードの先頭の改行、スペースを取り除く
           Dim t As String = Clipboard.GetText.TrimStart

           If String.IsNullOrEmpty(t) Then
              Beep()
           Else

           'クリップボードの最初の一行を取り出し、
           'ファイル名に使用できない文字を取り除く

              Dim sr As New StringReader(t)
              Dim rt As String = sr.ReadLine()
              Dim nt As String = Regex.Replace(rt, _Remove_FileNamePattern, "").TrimStart
              sr.Close()

              If (nt.Length <> 0) AndAlso (nt <> Txt_BeforeName.Text) Then

                 RemoveHandler Txt_AfterName.TextChanged, AddressOf Txt_AfterName_TextChanged
                   Txt_AfterName.Text = nt
                 AddHandler Txt_AfterName.TextChanged, AddressOf Txt_AfterName_TextChanged

                 Me.DialogResult = DialogResult.OK
                 Me.Close()
              Else
                 Beep()
              End If
           End If
        End If
    End Sub

    Private Sub Btn_Clip_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Btn_Clip.Click

     'クリップボードの先頭の改行、スペースを取り除く
        Dim t As String = Clipboard.GetText.TrimStart

        If String.IsNullOrEmpty(t) Then
           Beep()
        Else

        'クリップボードの最初の一行を取り出し、
        'ファイル名に使用できない文字を取り除く(Txt_AfterName_TextChanged で処理)

           Dim sr As New StringReader(t)

           Txt_AfterName.Text = sr.ReadLine()
           Txt_AfterName.SelectAll()
           Txt_AfterName.Select()

           sr.Close()
        End If
    End Sub

#End Region

End Class