﻿'
'   Change Settings for Classic fixed Ver.
'
'     96Dpi 版 1.0.5.0 (AltFl NC)
'
'       Required Class:
'         ButtonEx.vb
'         CheckBoxSL.vb
'         ComboBoxEx
'         HorizontalTrackBar
'         LabelSL.vb
'
'       Required Property:
'         Owner.Font
'         Owner.HoverColor
'
Imports System.ComponentModel
Imports System.Drawing.Text
Imports System.Drawing.Drawing2D
Imports System.Reflection
Imports UserLib

Public Class Form_F1

    Public ColorName(9) As String

    Public Log_CheckSize As Integer
    Public Log_LeaveCount As Integer

    Public Lsv_FontName As String
    Public Lsv_FontSize_Id As Integer
    Public Lsv_FontSize As Single()

    Private _FontSizeMpf As Single

    Private _Alt As Boolean                 'Alt+[F1] 判定
    Private _ColorName() As String          '変更基準値
    Private _CheckStatus As Integer         '    〃
    Private _ExtPageValue As Integer        '    〃
    Private _LogPageValue As Integer        '    〃

    Private _EmphasisText As String() = {"なし", "淡い", "標準", "濃い"}

    Private _BaseScrollBarWidth As Integer  'スクロール バーの幅（基準値）

#Region "// Sub-Routine & Function"

''' <summary>
''' コンボボックスのフォントを設定します。
''' </summary>

    Private Sub ComboBoxFontSetting()

        Dim s1 As Single = 9.75F
        Dim s2 As Single = 10.5F

        If _FontSizeMpf <> 1.0F Then
           s1 = GetNearFontSize(s1 / _FontSizeMpf)
           s2 = GetNearFontSize(s2 / _FontSizeMpf)
        End If

        Lbl_Point.Font = New Font("Tahoma", s1)

        Dim f As Font

        For Each ctl As Control In Me.TabControl.TabPages

          If ctl.Name = "Tab_Log" Then
             f = New Font("Lucida Console", s2)
          Else
             f = New Font("Verdana", s1)
          End If

          For Each cctl As Control In ctl.Controls
            If cctl.GetType.Name = "ComboBoxEx" Then

            'ボタンの幅をスクロールバーの幅に対応させる為、クリア後再設定
               cctl.Font = Nothing
               cctl.Font = f
            End If
          Next
        Next

     'ComboBox の変更を反映
        TabControl.SelectTab(Tab_Log)
        TabControl.SelectTab(Tab_Color)
        TabControl.SelectTab(Tab_Font)

     '▼ボタンの幅（差分値）を補正
        AdjustScrolBarWidth()
    End Sub

''' <summary>
''' ▼ボタンの幅（差分値）を補正します
''' </summary>

    Private Sub AdjustScrolBarWidth()
        Dim w As Integer = SystemInformation.VerticalScrollBarWidth - _BaseScrollBarWidth

        If w <> 0 Then
           Cmb_Size.Width += w
           Cmb_Leave.Width += w

           _BaseScrollBarWidth += w     'スクロール バーの幅（基準値）を変更
        End If
    End Sub

''' <summary>
''' チェックボックスの状態を調べます。
''' </summary>

    Private Function CheckedState() As Integer

        Dim n As Integer
        Dim v As Integer

        For Each ctl As Control In Tab_Base.Controls
          v += Convert.ToInt32(DirectCast(ctl, CheckBoxSL).CheckState * (10 ^ n))
          n += 1
        Next

        Return v
    End Function

''' <summary>
''' Ext Page の設定値（合計）を取得します。
''' </summary>

    Private Function ExtPageValue() As Integer

        Dim s As String = _
             Convert.ToInt32(Chk_GridLines.Checked).ToString
        s &= Convert.ToInt32(Chk_CtrlUpDown.Checked).ToString
        s &= Trk_Emphasis.Value.ToString
        s &= Cmb_Culture.SelectedIndex.ToString
        s &= Cmb_DateTimeFormat.SelectedIndex.ToString

        Return Convert.ToInt32(s)
    End Function

''' <summary>
''' Log Page の設定値（合計）を取得します。
''' </summary>

    Private Function LogPageValue() As Integer

        Dim v As Integer = Cmb_Leave.SelectedIndex

        v += (10 * Cmb_Size.SelectedIndex)

        Return v
    End Function

''' <summary>
''' ColorName が変更されている場合は True を返します。
''' </summary>

    Private Function CheckColorName() As Boolean

        For i As Integer = 0 To ColorName.Length - 1
          If Not (ColorName(i) = _ColorName(i)) Then
             Return True
          End If
        Next

        Return False
    End Function

    Private Sub Btn_OK_Control()

        Dim s As Boolean =
            (Lsv_FontSize_Id <> Trk_FontSize.Value) OrElse
            (Lsv_FontName <> Cmb_FontName.Text) OrElse
            (_CheckStatus <> CheckedState()) OrElse
            (_ExtPageValue <> ExtPageValue()) OrElse
            (_LogPageValue <> LogPageValue()) OrElse
            (CheckColorName())

        Btn_OK.Visible = s
    End Sub

#End Region

    Public Overloads Sub Show(ByVal Owner As IWin32Window, ByVal alt As Boolean)

      Me.SuspendLayout()

        _Alt = alt

     'Tab 2 (Ext)
        Lbl_Emphasis.Text = _EmphasisText(Trk_Emphasis.Value)

     'Tab 3 (Log)
        Me.Cmb_Size.Items.AddRange(New Object() {"  4,096", "  8,192", " 16,384", " 32,768", " 65,536"})
        Me.Cmb_Leave.Items.AddRange(New Object() {" 1", " 2", " 3", " 4", " 5"})

        Dim id As Integer

        If Log_CheckSize <= 4096 Then
           id = 0
        ElseIf Log_CheckSize >= 65536 Then
           id = 4
        Else
           id = Convert.ToInt32(Math.Log(Log_CheckSize \ 4096) / Math.Log(2))
        End If
        Cmb_Size.SelectedIndex = id

        If Log_LeaveCount <= 1 Then
           id = 0
        ElseIf Log_LeaveCount >= 5 Then
           id = 4
        Else
           id = Log_LeaveCount - 1
        End If
        Cmb_Leave.SelectedIndex = id

     'Tab 4 (Color)
        For Each c As Color In TypeDescriptor.GetConverter(GetType(Color)).GetStandardValues
          Cmb_Name.Items.Add(c.Name)
        Next

        Me.Cmb_Type.Items.AddRange(New Object() {
          "Attribute (Read Only)", "Attribute (Hide)", "Attribute (System)",
          "itemsCount", "Success", "Failure", "Break", "Undo",
          "Hover (Main)", "Hover (Sub)"})

     '色名と色見本を表示
        Cmb_Type.SelectedIndex = 0

     'Tab 5 (Font)
        Dim SearchFontName As String() = New String() _
            {"Calibri", "Cambria", "Meiryo UI", "Segoe UI", "Century", _
             "IPA Pゴシック", "MeiryoKe_PGothic", "MeiryoKe_UIGothic", "Yu Gothic UI"}

        Me.Cmb_FontName.Items.AddRange(New Object() {
          "Arial", "Microsoft Sans Serif", "MS UI Gothic", "Palatino Linotype",
          "Tahoma", "Times New Roman", "Verdana", "ＭＳ Ｐゴシック"})

        Dim ifc As New InstalledFontCollection
        Dim ffm As FontFamily() = ifc.Families

        For Each ff As FontFamily In ffm
          If Array.IndexOf(SearchFontName, ff.Name) <> -1 Then
             Cmb_FontName.Items.Add(ff.Name)
          End If
        Next

        ifc.Dispose()

     'フォント名とサイズを表示
        Cmb_FontName.Sorted = True
        Cmb_FontName.SelectedItem = Lsv_FontName

     'リストにない場合は、追加して選択状態にする
        If Cmb_FontName.SelectedItem Is Nothing Then
           Cmb_FontName.Items.Add(Lsv_FontName)
           Cmb_FontName.SelectedItem = Lsv_FontName
        End If

        Trk_FontSize.Maximum = Lsv_FontSize.Length - 1
        Trk_FontSize.Value = Lsv_FontSize_Id
        Lbl_Point.Text = String.Format("{0:0.00}", Lsv_FontSize(Lsv_FontSize_Id))

     '値の変更を調べる為に、基準となる値をセット
        _CheckStatus = CheckedState()
        _ExtPageValue = ExtPageValue()
        _LogPageValue = LogPageValue()
        _ColorName = DirectCast(ColorName.Clone, String())

        Btn_Change.Visible = False
        Btn_OK.Visible = False

        Me.ShowDialog(Owner)

        If Me.DialogResult = DialogResult.OK Then
           Log_CheckSize = Convert.ToInt32(4096 * (2 ^ Cmb_Size.SelectedIndex))
           Log_LeaveCount = Cmb_Leave.SelectedIndex + 1

           Lsv_FontName = Cmb_FontName.Text
           Lsv_FontSize_Id = Trk_FontSize.Value
        End If
    End Sub

#Region "// Me"

    Private Sub Me_Load(sender As Object, e As EventArgs) Handles Me.Load

     'Owner Data (Font, Color) Set

        Me.Font = Owner.Font

     'スクロール バーの幅（基準値）
        _BaseScrollBarWidth = 16

        _FontSizeMpf = Me.CreateGraphics.DpiX / 96.0F

        ComboBoxFontSetting()

     'ラベルの位置を ComboBox に合わせる
        Label_L2.FixHeight = Cmb_Size.Height
        Label_L3.FixHeight = Cmb_Leave.Height

        Label_C1.Height = Cmb_Type.Height
        Label_C2.Height = Cmb_Name.Height
        Label_F1.Height = Cmb_FontName.Height

     'ComboBox の位置を右にずらす
        If Me.Font.Name = "Meiryo UI" Then

           Cmb_Size.Left += 6
           Cmb_Leave.Left += 6

        'タブの高さを変更
           TabControl.ItemSize = New Size(TabControl.ItemSize.Width, TabControl.ItemSize.Height + 1)
        End If

        Dim c As Color
        Dim pi As PropertyInfo = Owner.GetType.GetProperty("HoverColor")

        If Not pi Is Nothing Then
           c = DirectCast(pi.GetValue(Owner, Nothing), Color)
        End If

        For Each ctl As Control In Me.TabControl.TabPages
          For Each cctl As Control In ctl.Controls
            If cctl.GetType.Name = "CheckBoxSL" Then
               DirectCast(cctl, CheckBoxSL).HoverColor = c
            End If
          Next
        Next

        TabControl.SelectedTabColor = c

        Btn_OK.HoverColor = c
        Btn_Cancel.HoverColor = c
        Btn_Change.HoverColor = c

        If _Alt Then
           TabControl.SelectedTab = Tab_Font
           Trk_FontSize.Select()
        Else
           TabControl.SelectedTab = Tab_Base
           Chk_DialogBox.Select()
        End If

      Me.ResumeLayout()

        AddHandler TabControl.Selecting, AddressOf TabControl_Selecting
        AddHandler TabControl.SelectedIndexChanged, AddressOf TabControl_SelectedIndexChanged

        AddHandler Chk_DialogBox.CheckedChanged, AddressOf Chk_BasePage_CheckedChanged
        AddHandler Chk_ToolTip.CheckStateChanged, AddressOf Chk_BasePage_CheckedChanged
        AddHandler Chk_MsgSound.CheckedChanged, AddressOf Chk_BasePage_CheckedChanged
        AddHandler Chk_LogWrite.CheckedChanged, AddressOf Chk_BasePage_CheckedChanged
        AddHandler Chk_IniSave.CheckedChanged, AddressOf Chk_BasePage_CheckedChanged

        AddHandler Chk_GridLines.CheckedChanged, AddressOf Chk_ExtPage_CheckedChanged
        AddHandler Chk_CtrlUpDown.CheckedChanged, AddressOf Chk_ExtPage_CheckedChanged
        AddHandler Trk_FontSize.ValueChanged, AddressOf Trk_FontSize_ValueChanged
        AddHandler Cmb_Culture.SelectedIndexChanged, AddressOf Cmb_ExtPage_SelectedIndexChanged
        AddHandler Cmb_DateTimeFormat.SelectedIndexChanged, AddressOf Cmb_ExtPage_SelectedIndexChanged

        AddHandler Cmb_Size.SelectedIndexChanged, AddressOf Cmb_LogPage_SelectedIndexChanged
        AddHandler Cmb_Leave.SelectedIndexChanged, AddressOf Cmb_LogPage_SelectedIndexChanged

        AddHandler Cmb_FontName.SelectedValueChanged, AddressOf Cmb_FontName_SelectedValueChanged
        AddHandler Trk_Emphasis.ValueChanged, AddressOf Trk_Emphasis_ValueChanged
    End Sub

    Private Sub Me_SystemColorsChanged(sender As Object, e As EventArgs) Handles Me.SystemColorsChanged

     'ボタンの幅をスクロールバーの幅に対応させる為、再設定
        ComboBoxFontSetting()

        Btn_Change.BackColor = Me.BackColor
    End Sub

#Region "** Button"

    Private Sub Btn_OK_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Btn_OK.Click

        DialogResult = DialogResult.OK
    End Sub

#End Region

#End Region

#Region "// TabControl"

    Private Sub TabControl_Selecting(sender As Object, e As TabControlCancelEventArgs)

        If TabControl.SelectedTab IsNot Tab_Color Then
           If Btn_Change.Visible Then

           '変更をキャンセル
              Cmb_Name.Text = ColorName(Cmb_Type.SelectedIndex)
           End If
        End If
    End Sub

    Private Sub TabControl_SelectedIndexChanged(sender As Object, e As EventArgs)

        Select Case TabControl.SelectedIndex
          Case 0 : Chk_DialogBox.Select()
          Case 1 : Chk_GridLines.Select()
          Case 2 : Cmb_Size.Select()
          Case 3 : Cmb_Type.Select()
          Case 4 : Cmb_FontName.Select()
        End Select
    End Sub

#Region "** Tab - Base Setting"

    Private Sub Chk_BasePage_CheckedChanged(sender As Object, e As EventArgs)

        Btn_OK_Control()
    End Sub

#End Region

#Region "** Tab - Ext Setting"

    Private Sub Chk_ExtPage_CheckedChanged(sender As Object, e As EventArgs)

        Btn_OK_Control()
    End Sub

    Private Sub Trk_Emphasis_ValueChanged(sender As Object, e As System.EventArgs) Handles Trk_Emphasis.ValueChanged

        Lbl_Emphasis.Text = _EmphasisText(Trk_Emphasis.Value)

        Btn_OK_Control()
    End Sub

    Private Sub Cmb_ExtPage_SelectedIndexChanged(sender As Object, e As EventArgs)

        Btn_OK_Control()
    End Sub

#End Region

#Region "** Tab - Log"

    Private Sub Cmb_LogPage_SelectedIndexChanged(sender As Object, e As EventArgs)

        Btn_OK_Control()
    End Sub

#End Region

#Region "** Tab - Color"

    Private Sub Cmb_Type_SelectedValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles Cmb_Type.SelectedValueChanged

        Cmb_Name.Text = ColorName(Cmb_Type.SelectedIndex)
    End Sub

    Private Sub Cmb_Name_SelectedValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles Cmb_Name.SelectedValueChanged

        Dim Canvas As New Bitmap(PictureBox1.Width, PictureBox1.Height)
        Dim Graph As Graphics = Graphics.FromImage(Canvas)
        Dim Brush As New SolidBrush(Color.FromName(Cmb_Name.Text))

        Graph.FillRectangle(Brush, PictureBox1.DisplayRectangle)

        Brush.Dispose()
        Graph.Dispose()

        PictureBox1.Image = Canvas

        If Cmb_Type.Text.IndexOf("Hover") = 0 Then

           Dim c As Color = Color.FromName(Cmb_Name.Text)

           Btn_OK.HoverColor = c
           Btn_Cancel.HoverColor = c
           Btn_Change.HoverColor = c
        End If

        Btn_Change.Visible = Not (Cmb_Name.Text = ColorName(Cmb_Type.SelectedIndex))
    End Sub

    Private Sub Btn_Change_VisibleChanged(sender As Object, e As EventArgs) Handles Btn_Change.VisibleChanged
        If Btn_Change.Visible Then
           Me.AcceptButton = Btn_Change
        Else
           Me.AcceptButton = Btn_OK
        End If
    End Sub

    Private Sub Btn_Change_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Btn_Change.Click

        ColorName(Cmb_Type.SelectedIndex) = Cmb_Name.Text

        Btn_Change.Visible = False
        Btn_OK_Control()

        If Cmb_Type.Text.IndexOf("(Main)") <> -1 Then

           Dim c As Color = Color.FromName(Cmb_Name.Text)

        'Tab を更新
           TabControl.SelectedTabColor = c

           For Each ctl As Control In Me.TabControl.TabPages
             For Each cctl As Control In ctl.Controls
               If cctl.GetType.Name = "CheckBoxSL" Then
                  DirectCast(cctl, CheckBoxSL).HoverColor = c
               End If
             Next
           Next
        End If

        Cmb_Type.Select()
    End Sub

#End Region

#Region "** Tab - Font"

    Private Sub Cmb_FontName_SelectedValueChanged(sender As Object, e As EventArgs)

        Btn_OK_Control()
    End Sub

    Private Sub Trk_FontSize_ValueChanged(ByVal sender As Object, ByVal e As EventArgs)

        Lbl_Point.Text = String.Format("{0:0.00}", Lsv_FontSize(Trk_FontSize.Value))

        Btn_OK_Control()
    End Sub

#End Region

#End Region

End Class