﻿'
'   Change File Attributes
'
'     96Dpi 版 1.1.4.1 (AltTm NC 10p, AltFl NC 10p 共用)
'
'       Required Class:
'         ButtonEx.vb
'         CheckBoxSL.vb
'         LabelSL.vb
'
'       Required Property:
'         Owner.Font
'         Owner.ListView.Font
'         Owner.HoverColor
'         Owner.WarningColor
'
Imports System.IO

Public Class Form_F3

#Region "// constant, variable declaration"

    Private _FormResizeFlag As Boolean          'Form_Resize イベントキャンセルフラグ

 'フォーム(クライアント)のサイズ
    Private _MinClientWidth As Integer
    Private _MaxClientWidth As Integer

    Private _FixClientHeight As Integer         '固定（基準値） 

    Private _MinClientSize As Size
    Private _MaxClientSize As Size

    Private _Fname As String
    Private _Fattr As Integer

    Private _ChangeAttributes As Integer
    Private _BeforeAttributes As Integer

#End Region

    Public Overloads Sub Show(ByVal Owner As IWin32Window, ByVal FileName As String, ByRef FileAttr As Integer)

     'ファイル情報セット
        _Fname = FileName
        _Fattr = FileAttr

        Me.ShowDialog(Owner)

        If Me.DialogResult = DialogResult.OK Then
           FileAttr = _ChangeAttributes
        End If
    End Sub

#Region "// ---- Form -------------------------------------------------------------------"

    Private Sub Me_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load

      Me.SuspendLayout()

     'Owner Data Set
        Me.Font = Owner.Font

        Dim c As Color = DirectCast(Owner.GetType.GetProperty("HoverColor").GetValue(Owner, Nothing), Color)

        Chk_R.HoverColor = c
        Chk_H.HoverColor = c
        Chk_S.HoverColor = c
        Btn_Ok.HoverColor = c
        Btn_Cancel.HoverColor = c

        Lbl_FileName.Font = Owner.Controls("ListView").Font
        Lbl_FileName.Text = _Fname
'-------------------------------------------------------------------------------
     '画面制御変数・初期化
        Dim fw As Integer = SystemInformation.FrameBorderSize.Width * 2
        Dim fh As Integer = SystemInformation.CaptionHeight + fw

        _MinClientWidth = 320 - fw
        _MaxClientWidth = 1280 - fw

        _FixClientHeight = Me.ClientSize.Height

        _MinClientSize = New Size(_MinClientWidth, _FixClientHeight)
        _MaxClientSize = New Size(_MaxClientWidth, _FixClientHeight)

        Me.MinimumSize = New Size(_MinClientWidth + fw, Me.Height)
        Me.MaximumSize = New Size(_MaxClientWidth + fw, Me.Height)
'-------------------------------------------------------------------------------
     '属性セット
        If _Fattr = -1 Then
           Label1.Text = "(注意)"

           Chk_R.CheckState = CheckState.Indeterminate
           Chk_H.CheckState = CheckState.Indeterminate
           Chk_S.CheckState = CheckState.Indeterminate

           Lbl_FileName.ForeColor = DirectCast(Owner.GetType.GetProperty("WarningColor").GetValue(Owner, Nothing), Color)
        Else
           If (_Fattr And 16) = 16 Then
              Label1.Text = "フォルダ"
           End If

           Chk_R.Checked = ((_Fattr And 1) = 1)
           Chk_H.Checked = ((_Fattr And 2) = 2)
           Chk_S.Checked = ((_Fattr And 4) = 4)
        End If

        _BeforeAttributes = _Fattr

        Btn_Ok.Visible = False

        Me.Opacity = 1.0R

      Me.ResumeLayout()

        AddHandler Me.Resize, New EventHandler(AddressOf Me_Resize)

        AddHandler Chk_R.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
        AddHandler Chk_H.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
        AddHandler Chk_S.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
    End Sub

    Private Sub Me_Resize(ByVal sender As Object, ByVal e As EventArgs) 'Handles Me.Resize

        If _FormResizeFlag Then Return
'---------------------------------------------------------------------------------------------
'     画面のプロパティ(アクティブタイトルバー、ウィンドウの境界・間隔)が変更された時の処理
'     （ウィンドウサイズの変更のみ実施）
'---------------------------------------------------------------------------------------------
        Dim fw As Integer = SystemInformation.FrameBorderSize.Width * 2
        Dim fh As Integer = SystemInformation.CaptionHeight + fw
        Dim mw As Integer = _MinClientSize.Width + fw
        Dim mh As Integer = _MinClientSize.Height + fh

        If Me.Size = Me.MinimumSize Then

           If mw < Me.MinimumSize.Width OrElse mh < Me.MinimumSize.Height Then

              _FormResizeFlag = True

                Me.MinimumSize = New Size(mw, mh)
                Me.Size = Me.MinimumSize

              _FormResizeFlag = False
           End If
        Else
           If mw <> Me.MinimumSize.Width OrElse mh <> Me.MinimumSize.Height Then

              Me.MinimumSize = New Size(mw, mh)
           End If
        End If

        mw = _MaxClientSize.Width + fw
        mh = _MaxClientSize.Height + fh

        If Me.Size = Me.MaximumSize Then

           If mw > Me.MaximumSize.Width OrElse mh > Me.MaximumSize.Height Then

              _FormResizeFlag = True

                Me.MaximumSize = New Size(mw, mh)
                Me.Size = Me.MaximumSize

              _FormResizeFlag = False
           End If
        Else
           If mw <> Me.MaximumSize.Width OrElse mh <> Me.MaximumSize.Height Then

              Me.MaximumSize = New Size(mw, mh)
           End If
        End If
    End Sub

#End Region

    Private Sub Chk_RHS_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)

        If _BeforeAttributes = -1 Then
           _BeforeAttributes = -2

           RemoveHandler Chk_R.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
           RemoveHandler Chk_H.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
           RemoveHandler Chk_S.CheckedChanged, AddressOf Chk_RHS_CheckedChanged

           Chk_R.Checked = False
           Chk_H.Checked = False
           Chk_S.Checked = False

           AddHandler Chk_R.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
           AddHandler Chk_H.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
           AddHandler Chk_S.CheckedChanged, AddressOf Chk_RHS_CheckedChanged
        End If

        _ChangeAttributes = Convert.ToInt32(Chk_R.Checked) + _
                       (2 * Convert.ToInt32(Chk_H.Checked)) + _
                       (4 * Convert.ToInt32(Chk_S.Checked))

        Btn_Ok.Visible = (_BeforeAttributes <> _ChangeAttributes)
    End Sub

End Class
