﻿'
'   WinMessage 1.0.1.0
'
'     Clear:    キー(マウス)バッファクリア
'     KeyCheck: キーチェック
'
Imports System.Runtime.InteropServices
Imports System.Threading

Namespace UserLib

<DebuggerStepThrough()>
Public Class WinMessage
    Private Const PM_REMOVE As Integer = &H1
    Private Const PM_NOREMOVE As Integer = &H0
    Private Const WM_PAINT As Integer = &HF

    Private Const WM_KEYFIRST As Integer = &H100
    Private Const WM_KEYLAST As Integer = &H108
'
   'Private Const WM_NCMOUSEFIRST = &HA0
   'Private Const WM_NCMOUSELAST = &HA9
   'Private Const WM_MOUSEFIRST As Integer = &H200
   'Private Const WM_MOUSELAST As Integer = &H20A
'
   'Private Const WM_NCMOUSEMOVE = &HA0             '非クライアント領域でマウスが移動
   'Private Const WM_MDIMAXIMIZE = &HC225           'MDI子ウインドウを最大化
   'Private Const WM_KEYDOWN As Integer = &H100
   'Private Const WM_KEYUP As Integer = &H101
'
    Private Const WM_MOUSEMOVE As Integer = &H200
   'Private Const WM_LBUTTONDOWN As Integer = &H201
    Private Const WM_LBUTTONUP As Integer = &H202
   'Private Const WM_MOUSEWHEEL As Integer = &H20A
    Private Const WM_MOUSELEAVE As Integer = &H2A3

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Private Structure POINTAPI
        Public x As Integer        'x座標
        Public y As Integer        'y座標
    End Structure

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Private Structure MSG
        Public hwnd As IntPtr      'ウィンドウハンドル
        Public message As Integer  'メッセージID
        Public wParam As Integer   'WParamフィールド（メッセージID毎に異なる）
        Public lParam As Integer   'LParamフィールド（メッセージID毎に異なる）
        Public time As Integer     '時間
        Public pt As POINTAPI      'カーソル位置（スクリーン座標）
    End Structure

    <DllImport("User32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Private Shared Function PeekMessage( _
        ByRef lpMsg As MSG, _
        ByVal hwnd As IntPtr, _
        ByVal wMsgFilterMin As Integer, _
        ByVal wMsgFilterMax As Integer, _
        ByVal wRemoveMsg As Integer) As Boolean
    End Function

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Private Shared Function DispatchMessage( _
        ByRef lpMsg As MSG) As IntPtr
    End Function

''' <summary>
''' Windows Message を消去します。
''' </summary>

    Public Overloads Shared Sub Clear()
        Dim msg As MSG

        While PeekMessage(msg, Nothing, 0, 0, PM_REMOVE)
          Select Case msg.message
            Case WM_PAINT, WM_LBUTTONUP, WM_MOUSEMOVE, WM_MOUSELEAVE
              DispatchMessage(msg)
          End Select
        End While
    End Sub

''' <summary>
''' Windows Message を消去します。
''' </summary>

    Public Overloads Shared Sub Clear(ByVal Frm As IWin32Window, Optional ByVal SleepTime As Integer = 100)
'
'     SleepTime が100ms未満の場合は、指定値のまま1回
'                 100ms以上の場合は、100ms固定で複数回処理を繰り返す
'
        Dim n As Integer
        Dim msg As MSG

        If SleepTime <= 0 Then
           SleepTime = 0
           n = 1
        Else
           n = SleepTime \ 100
           If n = 0 Then
              n = 1
           Else
              SleepTime = 100
           End If
        End If

        For i = 1 To n
          If SleepTime > 0 Then Thread.Sleep(SleepTime)

          While PeekMessage(msg, Frm.Handle, 0, 0, PM_REMOVE)

            Select Case msg.message

             'WM_LBUTTONUPとWM_MOUSELEAVEはボタンの上にマウスがある時のホバー色を解除する為に処理
             'WM_MOUSEMOVEはボタンの上にマウスがある時のホバー色を変更する為に処理

              Case WM_PAINT, WM_LBUTTONUP, WM_MOUSEMOVE, WM_MOUSELEAVE
                DispatchMessage(msg)
            End Select
          End While
        Next
    End Sub

''' <summary>
''' 指定したキーが押されたかを調べます。
''' キーバッファ（メッセージキュー）はクリアされます。
''' </summary>

    Public Shared Function KeyCheck(ByVal Frm As IWin32Window, ByVal CheckKey As Keys) As Boolean
        Dim flg As Boolean
        Dim msg As MSG

        While PeekMessage(msg, Frm.Handle, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE)
          If msg.wParam = CheckKey Then flg = True
        End While

        Return flg
    End Function

End Class

End Namespace
