﻿'
'   AboutBoxEx: 1.1.4.0  (Classic & Visual Style Consolidated edition)
'
'       Required Class: 
'         ButtonEx.vb
'
'       Property: 
'         HoverColor
'
'   ※      呼出し元のフォームに HoverColor プロパティがある場合で、AboutBoxEx 呼出し時に
'           HoverColor プロパティの値が指定されていない場合、呼出し元の値が選択されます。
'
Imports System.Windows.Forms.VisualStyles
Imports System.Media
Imports System.Reflection

Namespace UserLib

<DebuggerStepThrough()>
Public NotInheritable Class AboutBoxEx

''' <summary>
''' ボタン上にマウスカーソルがある時のホバー色を指定します。
''' </summary>

    Public Property HoverColor() As Color

    Public Sub New()
        InitializeComponent()

        Const ControlMargin As Integer = 2
        Const RightSideWidth As Integer = 6

        Dim BaseX As Integer
        Dim w1, w2 As Integer

        Dim BaseWindowWidth As Integer = Me.Width
        Dim WindowFrameSize As Integer = SystemInformation.FixedFrameBorderSize.Width * 2
        Dim BothSideWidth As Integer = RightSideWidth + WindowFrameSize

        SystemSounds.Asterisk.Play()

        LabelProductName.Text = My.Application.Info.ProductName
        LabelVersion.Text = My.Application.Info.Version.ToString
        LabelCopyright.Text = My.Application.Info.Copyright

        BaseX = LabelProductName.Location.X
        LabelVersion.Left = BaseX + LabelProductName.Width + ControlMargin

        w1 = LabelProductName.Width + ControlMargin + LabelVersion.Width
        w2 = LabelCopyright.Width

        If w1 > w2 Then
           Me.Width = BaseX + w1 + BothSideWidth
        Else
           Me.Width = BaseX + w2 + BothSideWidth
        End If

'     Centering
       'OKButton.Left = (Me.Width - WindowFrameSize - OKButton.Width) \ 2

'     Right justified
        OKButton.Left = Me.Width - BothSideWidth - OKButton.Width
    End Sub

    <Obsolete("Showdialog(ByVal Owner As IWin32Window) を使用してください。", True)> _
    Public Overloads Sub Show()
    End Sub

    <Obsolete("Showdialog(ByVal Owner As IWin32Window) を使用してください。", True)> _
    Public Overloads Sub Show(ByVal Owner As IWin32Window)
    End Sub

    <Obsolete("Showdialog(ByVal Owner As IWin32Window) を使用してください。", True)> _
    Public Overloads Sub Showdialog()
    End Sub

    Private Sub Me_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load

        Dim sz As Single = Me.Font.Size

        Me.Font = New Font(Owner.Font.Name, sz)

        Dim h As Integer = (Me.Font.Height + 4) - OKButton.Height

        If h > 0 Then
           OKButton.Height += h
           Me.Height += h
        End If

        LogoPictureBox.Image = Owner.Icon.ToBitmap

' HoverColor Set
        Dim pi As PropertyInfo = Owner.GetType.GetProperty("HoverColor")

        If pi Is Nothing Then
           If _HoverColor = Nothing Then _HoverColor = SystemColors.Highlight
        Else
           If _HoverColor = Nothing Then
              _HoverColor = DirectCast(pi.GetValue(Owner, Nothing), Color)
              If _HoverColor = Nothing Then _HoverColor = SystemColors.Highlight
           End If
        End If
        OKButton.HoverColor = _HoverColor

        Me.Update()
        Me.Opacity = 1.0R
    End Sub

    Private Sub Me_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
        Me.Opacity = 0.0R
    End Sub

    Private Sub OKButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles OKButton.Click
        Me.Close()
    End Sub

End Class

End Namespace
